''' 
huge thank you to ash for making this script functional 

future improvements todo list:
- remove extra difficulties (i think i did this but i don't know if it works)
- figure out why the CHARTNAME assert breaks on metallic punisher???
- script-wide variables for more flexibility
'''

import os
import shutil
import simfile
from simfile.ssc import SSCSimfile
from simfile.types import Chart, Charts, Simfile

''' 
HOW TO FILL OUT srtFiles:
- have a google sheets
- copy your funny chartname columns into a text editor
- use multiline editing idk good luck (it's still faster than manually processing 50 damn files though)
'''

# obscured chartname, tier, group
# group -1 is reserved for quali/extras
srtFiles = [
	# example chart: ["Funny Chartname", 2, 3]

	# tier 1
	["Um Jammer Flammy", 1, 1],
	["Yo!", 1, 1],
	["Bass Music 2 Electric Bootylift", 1, 1],
	["Birdbath Aftermath", 1, 2],
	["sumSmash", 1, 2],
	["what if Flying Castle still on TV? lapix get ipad", 1, 2],
	["there's a slowdown at the end", 1, 3],
	["Crystal Palace Football Club", 1, 3],
	["A stop sign has 5 awesome angles", 1, 3],
	["The Dark Souls of Rhythms", 1, 4],
	["What do British people call elevators?", 1, 4],
	["A werewolf gets beat up by over 50 robots", 1, 4],

	# tier 2
	["Some Alan James bullheck", 2, 1],
	["JackOff Marathon (For Pleasure)", 2, 1],
	["Poggers Rock", 2, 1],
	["SWITCH! SWITCH! SWITCH!", 2, 2],
	["Sheldon Cooper's famous catchphrase", 2, 2],
	["Copied from Copied from Blank", 2, 2],
	["The Counter Culture does not conform to Click Tracks", 2, 3],
	["Newgrounds bops", 2, 3],
	["just got povited for bovid", 2, 3],
	["You don't know jack", 2, 4],
	["toca la guitarra", 2, 4],
	["one difficulty below Vicious Heroism btw", 2, 4],

	# tier 3
	["I should have submitted this for Dimocracy 2022 R1", 3, 1],
	["Lateral flow immunochromatographic assay", 3, 1],
	["I LOVE BED'S LAMB", 3, 1],
	["T pose and you'll auto quad", 3, 2],
	["is this a washing machine", 3, 2],
	["National Anthem of Tadpole Pond", 3, 2],

	# tier 4
	["Sengoku One String", 4, 1],
	["Harry Potter Faux News", 4, 1],
	["Nam Jun Paik Foot-Switch Experiment (1963)", 4, 1],
	["Just Accept", 4, 2],
	["There's probably a hint around here somewhere", 4, 2],
	["YIBBY, WE NEED TO ACTIVATE WARP DRIVE", 4, 2],

	# tier 5
	["If Trees Could Speak (mute edit)", 5, 1],
	["i think tournaments are ready for this yet", 5, 1],
	["OK who let Dameon on the mic again", 5, 1],
	["In The Groove Alexander Fourteen", 5, 1],
	["what if Flying City still on radio? lapix get iphone", 5, 1],

	# extra
	["The chart is full of many many cats", 6, -1],
	["Slaughterhouse Five", 6, -1],
	["MAGiCVLGiRL_F00TSVViTCH_B3VTZ", 6, -1],
	["Sorae Stop Sending Me Doubletap Charts For This SRT", 6, -1],
	["yet another unhinged combination of fs into brackets", 6, -1],
	["Sony T. was here", 6, -1],

	# qualifier
	["this will be tech in 2085", 7, -1],
]

# number is num of groups per tier
tierNames = [
	# example tier: ["Funny Subtitle," 4]
	["Tier for Naughty Children", 4],
	["Family Mine Funny Moments", 4],
	["Outer Edges of My Butthole", 2],
	["Effed Up Charts", 2],
	["Help", 1],
]

def anonymize(path: str):
	print(f"Anonymizing {path}")
	with simfile.mutate(path) as sim:
		for chart_ in sim.charts:
			chart: Chart = chart_ # typing workaround

			# Remove all non-expert difficulties
			if chart and chart.stepstype == 'dance-single' and chart.difficulty == 'Challenge':
				sim.charts = [chart] # this might break horribly
			
			# Change title to chartname and clear chartname afterwards
			#assert "CHARTNAME" in chart, f"File {sim.title} does not have a CHARTNAME" # this assert breaks on metallic punisher for some reason???
			if "CHARTNAME" in chart and chart.difficulty == 'Challenge': # god
				newTitle = chart.chartname
				sim.title = newTitle
				chart.chartname = ""

		# Obfuscate other aspects of the simfile 
		sim.titletranslit = ""
		sim.artisttranslit = ""
		sim.artist = "???"
		sim.preview = "../Resources/silent.ogg"
		sim.subtitle = ""
		sim.samplestart = "0.000"
		sim.samplelength = "10.000"
		#sim.background = "../Resources/bg.png"
		#sim.banner = "../bn.png"

# Remove .sm, .old, .auto files
def wipesm(path: str):
	for item in os.listdir(path):
		ext = [".sm", ".old", ".auto"]
		for i in range(len(ext)):
			if item.endswith(ext[i]):
				print(f"Cleaning {ext[i]} of {path}")
				os.remove(os.path.join(path, item))

# Create folders
def createFolders():
	print("Creating folders...")
	root = os.getcwd()
	for i in range(len(tierNames)):
		for j in range(tierNames[i][1]):
			# Make a folder with appropriate naming
			newpath = os.path.join(root, "TPE Tier " + str(i + 1) + " - " + tierNames[i][0] + " (Group " + str(j + 1) + ")")
			os.mkdir(newpath)

			# Copy simfile resources over (silent, bg, appropriate banner)
			os.mkdir(os.path.join(newpath, "Resources"))
			shutil.copyfile(os.path.join(root, "Resources/silent.ogg"), os.path.join(newpath, "Resources/silent.ogg"))
			shutil.copyfile(os.path.join(root, "Resources/tpe bg.png"), os.path.join(newpath, "Resources/tpe bg.png"))
			shutil.copyfile(os.path.join(root, "Resources/tpe bn t" + str(i + 1) + ".png"), os.path.join(newpath, "bn.png"))
	
	# Create extra/qualifier folders on their own
	qualipath = os.path.join(root, "TPE - Qualifier")
	os.mkdir(qualipath)
	os.mkdir(os.path.join(qualipath, "Resources"))
	shutil.copyfile(os.path.join(root, "Resources/silent.ogg"), os.path.join(qualipath, "Resources/silent.ogg"))
	shutil.copyfile(os.path.join(root, "Resources/tpe bg.png"), os.path.join(qualipath, "Resources/tpe bg.png"))
	shutil.copyfile(os.path.join(root, "Resources/tpe bn quali.png"), os.path.join(qualipath, "bn.png"))

	expath = os.path.join(root, "TPE - Extras")
	os.mkdir(expath)
	os.mkdir(os.path.join(expath, "Resources"))
	shutil.copyfile(os.path.join(root, "Resources/silent.ogg"), os.path.join(expath, "Resources/silent.ogg"))
	shutil.copyfile(os.path.join(root, "Resources/tpe bg.png"), os.path.join(expath, "Resources/tpe bg.png"))
	shutil.copyfile(os.path.join(root, "Resources/tpe bn extra.png"), os.path.join(expath, "bn.png"))
	print("Folders created.")

# Move files into group folders
# path should be the folder of the simfile
def createSRT(path: str):
	root = os.getcwd()
	toPath = ""
	fromPath = ""
	if path.ssc_path:
		with simfile.mutate(path.ssc_path) as sim:
			print(f"Moving {path.simfile_dir}")

			# This is going off of obscufated titles - intended to be ran after anonymize()
			# index() is a binch and won't work properly with multidim arrays fuck you
			ind = -1
			for i in range(len(srtFiles)):
				if srtFiles[i][0].lower().strip() == sim.title.lower().strip(): # FUCK
					ind = i
					print(f"Found file, ind = {ind}")
					
			assert ind >= 0, f"Title {sim.title} not found in srtFiles list"

			# Set appropriate metadata and find the folder to move to
			sim.background = "../Resources/tpe bg.png"
			sim.banner = "../bn.png"
			
			if srtFiles[ind][1] == 7: # qualifier
				toPath = os.path.join(root, "TPE - Qualifier")

			elif srtFiles[ind][1] == 6: # extras
				toPath = os.path.join(root, "TPE - Extras")

			else: # regular files
				toPath = os.path.join(root, "TPE Tier " + str(srtFiles[ind][1]) + " - " + tierNames[srtFiles[ind][1] - 1][0] + " (Group " + str(srtFiles[ind][2]) + ")")
			
			fromPath = path.simfile_dir

	for subdir, dirs, files in os.walk(root):
		if subdir == toPath:
			shutil.move(fromPath, toPath)



def main():
	path = os.getcwd()
	createFolders()
	for simfileDir in simfile.dir.SimfilePack(path).simfile_dirs():
		if simfileDir.ssc_path:
			anonymize(simfileDir.ssc_path)
			# Don't wipe .sm files if there is no .ssc file, just in case
			wipesm(simfileDir.simfile_dir)
	
	for simfileDir in simfile.dir.SimfilePack(path).simfile_dirs():
		createSRT(simfileDir) ## do this after because idk lmfao

if __name__ == "__main__":
	main() 